
(** Takes as input some ocaml files and the output file name, and
   generates 2 ocaml files 
    - 1 that defines a skeleton ocaml program for dealing with algo states
    - 1 that (Algo.)register(s) the (input) algorithms.

 Existing output file won't be overrided (a warning is printed).

 The input files ougth to define a module implementing the following interface:

    val name: string
    val actions : string list option;
    val init_state: int -> state
    val enable_f: state Algo.neighbor list -> state -> Algo.action list
    val step_f  : state Algo.neighbor list -> state -> Algo.action -> state
    val state_to_string: state -> string

 The algo state definition file implements the following interface:

    type state
    val state_copy : state -> state
    val state_of_string: (string -> state) option
    val copy_state: state -> state  

  *)

val f: string list -> string * string -> unit
