(* Time-stamp: <modified the 06/09/2019 (at 15:51) by Erwan Jahier> *)

type 'v t = {
  pid : string;
  actions: Register.action list;
  init : 'v;
  enable : 'v Register.enable_fun;
  step : 'v Register.step_fun ;
}

let (make: bool -> Topology.node -> 'v -> 'v t) =
  fun custom_mode n init ->
    let pid = n.Topology.id in
    let ml = n.Topology.file in
    let id = Filename.chop_suffix ml ".ml" in
    let actions =
      try Register.get_actions id
      with _ ->
        if custom_mode then
          failwith
            "Registering actions is mandatory in algorithms when using custom demon!"
        else ["a"]
    in
    let process = {
      pid = pid;
      init = init;
      actions = actions;
      enable = Register.get_enable id; 
      step = Register.get_step id;
    }
    in
    process

