(* Time-stamp: <modified the 06/09/2019 (at 15:51) by Erwan Jahier> *)

(** There is such a Process.t per node in the dot file. *)
type 'v t = {
  pid : string; (* unique *)
  actions: Register.action list;
  init : 'v;
  enable : 'v Register.enable_fun;
  step : 'v Register.step_fun;
}

(** [make custom_mode_flag node init_state] builds a process out of a dot
   node. To do that, it retreives the registered functions by Dynamic
   linking of the cmxs file specified in the "algo" field of the dot
   node.

    nb: it provides variable initial values if not done in the dot
   (via the init field) nor in the Algo (via Algo.reg_init_vars) *)
val make: bool -> Topology.node -> 'v -> 'v t
