
(* 'v is the type of Algo local state, and is defined by users. In
   order to avoid the need for the user to define (and register a set
   of functions over such a state type, we try to guess them using
   only one of them: Algo.to_string (obtained via
   Algo.get_value_to_string).

   The reasons for doing that are: 

   - it is only required for interacting with synchronous tools in RIF 
   - it is boring to do 
   - it is not so easy, as all func definitions should be consistent

   Moreover, it also provides a mean to hide some information. Indeed,
   if the user only want to show part of the local state, he can.

*)


(* All the remaining fonctions are based on Algo.to_string *)

type pid = string
val to_var_names : pid -> 'v -> string list 

(** used to produce RIF *)
val to_rif_decl   : pid -> 'v -> (string * Data.t) list
val to_rif_data : 'v -> string


(** used to interact with rdbg *)
val to_rdbg_subst : pid -> 'v -> (string * Data.v) list
                                      
