
(** {1 Some printers } *)

open Register
let (algo_neighbor : 'v Register.neighbor -> string) = fun n ->
  Printf.sprintf "%s (%s)" (n.pid()) (Register.to_string n.state)

open Process
let (env: 'v Env.t -> 'v Process.t list -> string) =
  fun env pl ->
    let value_to_string = Register.get_value_to_string () in
    let l = List.map 
        (fun p ->
           Printf.sprintf "%s: %s" p.pid
             (value_to_string (Env.get env p.pid)))
        pl
    in
    String.concat ", " l


let (env_rif: 'v Env.t -> 'v Process.t list -> string) =
  fun env pl ->
    let l = List.map 
        (fun p ->
           Printf.sprintf "%s" (SasaState.to_rif_data (Env.get env p.pid)))
        pl
    in
    String.concat " " l

