(* Time-stamp: <modified the 18/11/2019 (at 10:26) by Erwan Jahier> *)

(** {1 Topology: internal representation of Graphs } *)

type node_id = string
type node = {
  id: node_id; (** The id of the node as stated in the dot file *)
  file: string; (** the content of the algo field (a ml file) *)
  init: string; (** store the content of the init field *)
}


type t = {
  nodes: node list; (** *)
  succ: node_id -> (int option * node_id) list; (** get neighbors, with weigth if any *)
  of_id: node_id -> node; (** *)
  directed:bool (** true if the graph is directed *)
}

(** Parse a sasa dot file *)
val read: string -> t

(** {1 Various eponymous util funtions } *)
  
val to_adjency: t -> bool array array
val get_nb_link: t -> int
val get_mean_degree : t -> float
val is_connected_and_cyclic : t -> bool * bool
val height : string list -> t -> string -> int
val get_height : t -> string -> int
val get_degree: t -> int * int    

