(* Time-stamp: <modified the 25/09/2019 (at 13:52) by Erwan Jahier> *)

open Algo

let k=3

let (init_state: int -> 'v) = fun _i -> Random.int k 

let (clash : 'v neighbor list -> 'v list) = fun nl -> 
  let res = List.map (fun n -> state n) nl in
  res

let (free : 'v neighbor list -> 'v list) = fun nl ->
  let clash_list = List.sort_uniq compare (clash nl) in
  let rec aux free clash i =
    if i > k then free else
      (match clash with
       | x::tail ->
         if x = i then aux free tail (i+1) else aux (i::free) clash (i+1)
       | [] -> aux (i::free) clash (i+1)
      )
  in
  let res = aux [] clash_list 0 in
  List.rev res

let (enable_f: 'v -> 'v neighbor list -> action list) =
  fun e nl ->
    if List.mem e (clash nl) then ["conflict"] else []
  
let (step_f : 'v -> 'v neighbor list -> action -> 'v) =
  fun e nl ->
    function  | _ ->
      if (Random.bool ()) then e else (List.hd (free nl))

let actions = Some ["conflict"];


